/* Operating Systems and Process-Oriented Programming
 * Uppsala University - 2019 Spring
 * Critical sections and mutual exclusion.
 * Two threads executing chunks of work in lock steps.
 * Copyright © 2019 Henrik Alfken(Schulze), Nikos Nikoleris
 Inspired by: https://www.it.uu.se/education/course/homepage/os/vt19/module-4/rendezvous/
rendezvous.c
 Compile and run by copy-pasting:
make clean && make bin/rendezvous && bin/rendezvous
 --OR--
make bin/rendezvous && bin/rendezvous
 */
#include <pthread.h> // pthread_...()
#include <semaphore.h> // sem_...()
#include <stdbool.h>   // true, false
#include <stdio.h>   // printf()
#include <stdlib.h>  // abort(), [s]rand()
#include <unistd.h>  // usleep()
#define LOOPS 13
#define MAX_SLEEP_TIME 3
#define SYNCH false     // If true synchronize, if false don't.

// TODO: Make the two threads perform their iterations in lockstep:
void * thread_a(void *param __attribute__((unused))) {
  int i;
  for (i = 0; i < LOOPS; i++) {
    printf("A %2d\n", i);
    usleep(1 + rand() % MAX_SLEEP_TIME); // Simulating time needed for work done by this thread.
  }
  pthread_exit(0);
}

// TODO: Make the two threads perform their iterations in lockstep:
void * thread_b(void *param  __attribute__((unused))) {
  int i;
  for (i = 0; i < LOOPS; i++) {
    printf("B %2d\n", i);
    usleep(1 + rand() % MAX_SLEEP_TIME); // Simulating time needed for work done by this thread.
  }
  pthread_exit(0);
}

int main() {
  pthread_t tid_a, tid_b;
  srand(time(NULL));
  pthread_setconcurrency(3);
  if (pthread_create(&tid_a, NULL, thread_a, NULL) ||
    pthread_create(&tid_b, NULL, thread_b, NULL)) {
    perror("pthread_create");
    abort();
  }
  if (pthread_join(tid_a, NULL) != 0 ||
    pthread_join(tid_b, NULL) != 0) {
    perror("pthread_join");
    abort();
  }
  puts("");
  return EXIT_SUCCESS;
}
